--- old/usr/src/uts/common/fs/vnode.c	Fri Jul 19 18:39:53 2013
+++ new/usr/src/uts/common/fs/vnode.c	Fri Jul 19 18:39:53 2013
@@ -65,6 +65,7 @@
 #include <fs/fs_subr.h>
 #include <sys/taskq.h>
 #include <fs/fs_reparse.h>
+#include <sys/fsh_impl.h>
 
 /* Determine if this vnode is a file that is read-only */
 #define	ISROFILE(vp)	\
@@ -3141,9 +3142,13 @@
 	}
 
 	VOPXID_MAP_CR(vp, cr);
+	
+	/*
+	 * Control is passed to fsh. In the end, underlying vop_vopen()
+	 * is called.
+	 */
+	ret = fsh_open(vpp, mode, cr, ct);
 
-	ret = (*(*(vpp))->v_op->vop_open)(vpp, mode, cr, ct);
-
 	if (ret) {
 		/*
 		 * Use the saved vp just in case the vnode ptr got trashed
@@ -3192,8 +3197,8 @@
 	int err;
 
 	VOPXID_MAP_CR(vp, cr);
-
-	err = (*(vp)->v_op->vop_close)(vp, flag, count, offset, cr, ct);
+	
+	err = fsh_close(vp, flag, count, offset, cr, ct);
 	VOPSTATS_UPDATE(vp, close);
 	/*
 	 * Check passed in count to handle possible dups. Vnode counts are only
@@ -3224,8 +3229,8 @@
 	ssize_t	resid_start = uiop->uio_resid;
 
 	VOPXID_MAP_CR(vp, cr);
-
-	err = (*(vp)->v_op->vop_read)(vp, uiop, ioflag, cr, ct);
+	
+	err = fsh_read(vp, uiop, ioflag, cr, ct);
 	VOPSTATS_UPDATE_IO(vp, read,
 	    read_bytes, (resid_start - uiop->uio_resid));
 	return (err);
@@ -3244,7 +3249,7 @@
 
 	VOPXID_MAP_CR(vp, cr);
 
-	err = (*(vp)->v_op->vop_write)(vp, uiop, ioflag, cr, ct);
+	err = fsh_write(vp, uiop, ioflag, cr, ct);
 	VOPSTATS_UPDATE_IO(vp, write,
 	    write_bytes, (resid_start - uiop->uio_resid));
 	return (err);
